//
// (C) 2004 Mike Brent aka Tursi aka HarmlessLion.com
// This software is provided AS-IS. No warranty
// express or implied is provided.
//
// This notice defines the entire license for this code.
// All rights not explicity granted here are reserved by the
// author.
//
// You may redistribute this software provided the original
// archive is UNCHANGED and a link back to my web page,
// http://harmlesslion.com, is provided as the author's site.
// It is acceptable to link directly to a subpage at harmlesslion.com
// provided that page offers a URL for that purpose
//
// Source code, if available, is provided for educational purposes
// only. You are welcome to read it, learn from it, mock
// it, and hack it up - for your own use only.
//
// Please contact me before distributing derived works or
// ports so that we may work out terms. I don't mind people
// using my code but it's been outright stolen before. In all
// cases the code must maintain credit to the original author(s).
//
// -COMMERCIAL USE- Contact me first. I didn't make
// any money off it - why should you? ;) If you just learned
// something from this, then go ahead. If you just pinched
// a routine or two, let me know, I'll probably just ask
// for credit. If you want to derive a commercial tool
// or use large portions, we need to talk. ;)
//
// If this, itself, is a derived work from someone else's code,
// then their original copyrights and licenses are left intact
// and in full force.
//
// http://harmlesslion.com - visit the web page for contact info
//
//*****************************************************
//* Ami 99 - TI Emulator for Win32					  *
//* by M.Brent                                        *
//* Win32 WindowProc                                  *
//*****************************************************

#define WIN32_LEAN_AND_MEAN
#define _WIN32_WINNT 0x0400

#include <stdio.h>
#include <windows.h>
#include <malloc.h>
#include <commctrl.h>
#include <commdlg.h>
#include <atlstr.h>

#include "resource.h"
#include "tiemul.h"
#include "keyboard/kb.h"

extern HDC tmpDC;
extern int max_volume;
extern int starttimer9901;
extern int timer9901;										// 9901 interrupt timer
extern int timer9901IntReq;
extern int timer9901IntOk;
extern int nSystem;
extern int nCartGroup;
extern int nCart;
extern int keyboard, ps2keyboardok;
extern bool fKeyEverPressed;
extern int nSampleIdx[3];
extern bool fSampleShouldLoop[3];
extern void GenerateToneBuffer(int idx);
extern int max_cpf, oldmax;
// needed for configuration
extern char AVIFileName[256];
extern int drawspeed, fJoy, joy1mode, joy2mode;
extern int slowdown_keyboard;
extern HINSTANCE hInstance;						// global program instance
extern int TVFiltersAvailable;
extern int TVScanLines;
extern volatile signed long cycles_left;		// runs the CPU throttle
extern struct CARTS Users[];
extern int BreakPointType[];
extern int BreakPoint[];
extern int nBreakPoints;
extern char lines[34][DEBUGLEN];				// debug lines
extern bool bDebugDirty;
extern Word disasm[20];							// last 20 addresses for disasm
extern bool bScrambleMemory;
// VDP tables
extern int SIT, CT, PDT, SAL, SDT, CTsize, PDTsize;
extern bool CPUSpeechHalt;
extern Byte CPUSpeechHaltByte;
extern int cpucount, cpuframes;					// CPU counters for timing
extern int timercount;							// Used to estimate runtime
// sams config
extern int sams_enabled, sams_size;
extern Byte staticCPU[0x10000];					// main memory for debugger

#include <mmsystem.h>
#include <dsound.h>
extern LPDIRECTSOUNDBUFFER voice[3];						// Voice buffers
extern LPDIRECTSOUNDBUFFER noise[8];						// Noise buffers
extern LPDIRECTSOUNDBUFFER speechbuf;						// Speech/DAC buffer
extern int nCycleCount;
const char *pCurrentHelpMsg=NULL;
HWND hKBMap=NULL;
HWND hBrkHlp=NULL;
HWND hTVDlg=NULL;
bool bFrozenText=false;

#ifndef GET_X_LPARAM
#define GET_X_LPARAM(x) (x&0xffff)
#endif
#ifndef GET_Y_LPARAM
#define GET_Y_LPARAM(y) (y>>16)
#endif

static LONG nOldVolume[11]={ -10000, -10000, -10000, -10000, -10000, -10000, -10000, -10000, -10000, -10000, -10000};

// Stuff for the debug window
HANDLE hDebugWindowUpdateEvent = CreateEvent(NULL, false, false, NULL);
static int nMemType=0;
// top addresses for the memory banks
static char szTopMemory[5][32] = { "", "", "R0", "R0", "R0" };		// CPU, VDP, GROM - hex address or Register number (Rx)

// references
BOOL CALLBACK DebugBoxProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK BreakPointHelpProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

/////////////////////////////////////////////////////////////////////////
// Window handler
/////////////////////////////////////////////////////////////////////////
LONG FAR PASCAL myproc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	// winuser.h has the VK_key key defines
	// also fill in the key[] array for on/off
    
	PAINTSTRUCT ps;
    HDC hDC;
	char szTemp[1024];
	float height;
	int i1;
	RECT myrect, myrect2;

	if (myWnd == hwnd) {	// Main TI window
		switch(msg) {
		case WM_INITMENUPOPUP:
			if (IsClipboardFormatAvailable(CF_TEXT)) {
				EnableMenuItem(GetMenu(myWnd), ID_EDITPASTE, MF_ENABLED | MF_BYCOMMAND);
			} else {
				EnableMenuItem(GetMenu(myWnd), ID_EDITPASTE, MF_GRAYED | MF_BYCOMMAND);
			}
			break;

		case WM_DISPLAYCHANGE:
			if (NULL != tmpDC) {
				DeleteDC(tmpDC);
				tmpDC=CreateCompatibleDC(NULL);
			}
			break;
		
		case WM_PAINT:
			hDC = BeginPaint(hwnd, &ps);
			GetClientRect(myWnd, &myrect);
			if (StretchMode==0) {
				FillRect(hDC, &myrect, (HBRUSH)(COLOR_MENU+1));
			}
			SetEvent(BlitEvent);
			EndPaint(hwnd, &ps);
			break;

		case WM_DESTROY:
			quitflag=1;
			PostQuitMessage(0);
			break;
		
		case WM_KEYDOWN:
			key[wParam]=1;
			if (lParam&0x1000000) {
				decode(0xe0);	// extended
			}
			decode(wParam);
			fKeyEverPressed=true;
			break;

		case WM_KEYUP:
			key[wParam]=0;
			if (lParam&0x1000000) {
				decode(0xe0);	// extended
			}
			decode(0xf0);	// key up
			decode(wParam);
			break;

		case WM_SYSKEYDOWN:				// returns from ALT and ALT+KEY (I use as FCTN)
			// some system keys we want Windows to process, namely F4 (close)
			if ((wParam != VK_F4) & (wParam != VK_RETURN))
			{	
				key[wParam]=1;
				if (lParam&0x1000000) {
					decode(0xe0);	// extended
				}
				decode(wParam);
			}
			else
			{
				switch (wParam)
				{
				case VK_F4:
					quitflag=1;
					PostQuitMessage(0);
					break;
				
				default:
					return(DefWindowProc(hwnd, msg, wParam, lParam));
				}
			}
			break;

		case WM_SYSKEYUP:
			key[wParam]=0;
			if (lParam&0x1000000) {
				decode(0xe0);	// extended
			}
			decode(0xf0);	// key up
			decode(wParam);
			break;

		case WM_SYSCHAR:
			// Don't remove this check, even if we need no ALT keys - otherwise all FCTN keys on the TI ding ;)
			// Fullscreen toggle - Alt-Enter
			if ((wParam==VK_RETURN)&&((lParam&0x8000)==0)) {
				if (3 == StretchMode) {
					StretchMode=2;
					PostMessage(hwnd, WM_COMMAND, ID_VIDEO_STRETCHMODE_NONE+StretchMode, 1);
				} else {
					if ((2 == StretchMode) && (0 != FullScreenMode)) {
						StretchMode=3;
						PostMessage(hwnd, WM_COMMAND, ID_VIDEO_STRETCHMODE_DXFULL_320X240X8+FullScreenMode-1, 1);
					}
				}
			}
			break;

		case WM_LBUTTONDBLCLK: 
			{
				// If in text mode, paste the character under the mouse cursor to the TI
				char ch;
				if (NULL != PasteString) {
					Beep(550,100);
					break;
				}
				GetClientRect(myWnd, &myrect);
				ch=VDPGetChar(GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam), myrect.right-myrect.left, myrect.bottom-myrect.top);
				if (-1 != ch) {
					PasteString=(char*)malloc(2);
					PasteString[0]=ch;
					PasteString[1]='\0';
					PasteIndex=PasteString;
				}
			}
			break;

		case WM_COMMAND:
			// Check for dynamic ones first, so we don't need a huge switch
			if ((wParam >= ID_SYSTEM_0) && (wParam < ID_SYSTEM_0+100)) {
				// user requested to change system
				int ret;
				if ((!lParam)&&(fKeyEverPressed)) {
					ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change System Type", MB_YESNO|MB_ICONQUESTION);
				} else {
					ret=IDYES;
				}
				if (IDYES == ret) {
					nSystem=wParam-ID_SYSTEM_0;
					for (int idx=0; idx<100; idx++) {
						if (idx == nSystem) {
							CheckMenuItem(GetMenu(myWnd), ID_SYSTEM_0+idx, MF_CHECKED);
						} else {
							CheckMenuItem(GetMenu(myWnd), ID_SYSTEM_0+idx, MF_UNCHECKED);
						}
					} 
					// Special case for 99/4
					if (nSystem == 0) {
						keyboard=KEY_994;	// 99/4 layout
						MessageBox(myWnd, "Note: 99/4 does not always start. Exit and restart Classic99 to work around this. No PS/2 Keyboard support available.", "Compatibility Notes", MB_ICONINFORMATION|MB_OK);
					} else {
						// this lets the user disable ps2 keyboard support
						if (ps2keyboardok) {
							keyboard=KEY_994A_PS2;	// 99/4A with ps/2
						} else {
							keyboard=KEY_994A;		// 99/4A without ps/2
						}
					}
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			if ((wParam >= ID_APP_0) && (wParam < ID_APP_0+100)) {
				// user requested to change cartridge (apps)
				int ret;
				if (fKeyEverPressed) {
					ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change Cartridge", MB_YESNO|MB_ICONQUESTION);
				} else {
					ret=IDYES;
				}
				if (IDYES == ret) {
					int idx;
					bUseSDCard=false;
					nCartGroup=0;
					nCart=wParam-ID_APP_0;
					for (idx=0; idx<100; idx++) {
						if (idx == nCart) {
							CheckMenuItem(GetMenu(myWnd), ID_APP_0+idx, MF_CHECKED);
						} else {
							CheckMenuItem(GetMenu(myWnd), ID_APP_0+idx, MF_UNCHECKED);
						}
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_GAME_0+idx, MF_UNCHECKED);
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_USER_0+idx, MF_UNCHECKED);
					}
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			if ((wParam >= ID_GAME_0) && (wParam < ID_GAME_0+100)) {
				// user requested to change cartridge (games)
				int ret;
				if (fKeyEverPressed) {
					ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change Cartridge", MB_YESNO|MB_ICONQUESTION);
				} else {
					ret=IDYES;
				}
				if (IDYES == ret) {
					int idx;
					bUseSDCard=false;
					nCartGroup=1;
					nCart=wParam-ID_GAME_0;
					for (idx=0; idx<100; idx++) {
						if (idx == nCart) {
							CheckMenuItem(GetMenu(myWnd), ID_GAME_0+idx, MF_CHECKED);
						} else {
							CheckMenuItem(GetMenu(myWnd), ID_GAME_0+idx, MF_UNCHECKED);
						}
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_APP_0+idx, MF_UNCHECKED);
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_USER_0+idx, MF_UNCHECKED);
					}
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			if ((wParam >= ID_USER_0) && (wParam < ID_USER_0+100)) {
				// user requested to change cartridge (user)
				int ret;
				if (fKeyEverPressed) {
					ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change Cartridge", MB_YESNO|MB_ICONQUESTION);
				} else {
					ret=IDYES;
				}
				if (IDYES == ret) {
					int idx;
					bUseSDCard=false;
					nCartGroup=2;
					nCart=wParam-ID_USER_0;
					for (idx=0; idx<100; idx++) {
						if (idx == nCart) {
							CheckMenuItem(GetMenu(myWnd), ID_USER_0+idx, MF_CHECKED);
						} else {
							CheckMenuItem(GetMenu(myWnd), ID_USER_0+idx, MF_UNCHECKED);
						}
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_GAME_0+idx, MF_UNCHECKED);
					}
					for (idx=0; idx<100; idx++) {
						CheckMenuItem(GetMenu(myWnd), ID_APP_0+idx, MF_UNCHECKED);
					}
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			// Any others?
			switch (wParam)
			{
			case ID_SDGROM_SELECT:
			// activate or reset SDGROM support
			{
				int ret;
				if (fKeyEverPressed) {
					ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change Cartridge", MB_YESNO|MB_ICONQUESTION);
				} else {
					ret=IDYES;
				}
				if (IDYES == ret) {
					nCartGroup=3;
					nCart=0;
					bUseSDCard=true;
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			break;

			case ID_CART_USER_OPEN:
			// Silence during the dialog
			for (int idx=0; idx<3; idx++) {
				voice[idx]->SetVolume(DSBVOLUME_MIN);
			}
			// Browse for user cartridge filename
			{
				OPENFILENAME ofn;
				char buf[256], buf2[256];

				memset(&ofn, 0, sizeof(OPENFILENAME));
				ofn.lStructSize=sizeof(OPENFILENAME);
				ofn.hwndOwner=hwnd;
				ofn.lpstrFilter="V9T9 Carts\0*.bin\0\0";
				strcpy(buf, "");
				ofn.lpstrFile=buf;
				ofn.nMaxFile=256;
				strcpy(buf2, "");
				ofn.lpstrFileTitle=buf2;
				ofn.nMaxFileTitle=256;
				ofn.Flags=OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;

				if ((GetSaveFileName(&ofn))&&(ofn.nFileExtension > 1)) {
					int nCnt, nIdx;

					strncpy(Users[0].szName, ofn.lpstrFileTitle, 32);
					Users[0].szName[31]='\0';
					Users[0].pDisk=NULL;
					Users[0].szMessage=NULL;
					nCnt=0;
					for (nIdx=0; nIdx<4; nIdx++) {
						switch (nIdx) {
							case 0:	
								ofn.lpstrFile[ofn.nFileExtension-2]='C'; 
								Users[0].Img[nCnt].nType=TYPE_ROM;
								break;
							case 1: 
								ofn.lpstrFile[ofn.nFileExtension-2]='D'; 
								Users[0].Img[nCnt].nType=TYPE_XB;
								break;
							case 2: 
								ofn.lpstrFile[ofn.nFileExtension-2]='G'; 
								Users[0].Img[nCnt].nType=TYPE_GROM;
								break;
							case 3: 
								ofn.lpstrFile[ofn.nFileExtension-2]='#'; 
								Users[0].Img[nCnt].nType=TYPE_NONE;
								break;
						}
						if (nCnt < 3) {
							FILE *fp=fopen(ofn.lpstrFile, "rb");
							if (NULL != fp) {
								fseek(fp, 0, SEEK_END);
								Users[0].Img[nCnt].dwImg=NULL;
								Users[0].Img[nCnt].nLoadAddr=(unsigned short)0x6000;
								Users[0].Img[nCnt].nLength=(unsigned short)ftell(fp);
								strncpy(Users[0].Img[nCnt].szFileName, ofn.lpstrFile, 1024);
								Users[0].Img[nCnt].szFileName[1023]='\0';
								nCnt++;
								fclose(fp);
								debug_write("Found %s...", ofn.lpstrFile);
							} else {
								Users[0].Img[nCnt].nType=TYPE_NONE;
							}
						}
					}
					bUseSDCard=false;
					nCartGroup=2;
					nCart=0;
					SendMessage(hwnd, WM_COMMAND, ID_FILE_RESET, 0);
				}
			}
			break;

			case ID_HELP_ABOUT:
				sprintf(szTemp, "Classic99 %s\n"\
								"By Mike Brent (Tursi)\n"\
								"(C)1994-2007\n\n"\
								"ROM data included under license from Texas Instruments.\n\n"\
								"Thanks to TI, Roland Meier, Jeff Brown, Frank\n"\
								"Palazolo and Ralph Nebet for assistance.\n\n"\
								"Contains additional code by:\n"\
								"Joe Delekto - SAMS support\n"\
								"MESS Team - Speech, with thanks to\n"\
								"Ralph Nebet for speech ROM help.\n"\
								"John Butler - 9900 Disasm\n"\
								"Derek Liauw Kie Fa - 2xSaI Renderer\n"\
								"2xSaI code from the SNES9x project\n\n"\
								"hq4x code by Maxim Stepin\n\n"\
								"Shay Green for the TV Filter\n\n"\
								"Keyboard map by Ron Reuter - www.mainbyte.com\n\n"\
								"tursi@harmlesslion.com\n"\
								"http://harmlesslion.com/software/classic99", 
						VERSION);
				MessageBox(myWnd, szTemp, "Classic99 About", MB_OK);
				return 0;
				break;

			case ID_HELP_KBMAP: 
				{
					if (NULL == hKBMap) {
						// create a modeless dialog to show the keyboard map
						hKBMap=CreateDialog(NULL, MAKEINTRESOURCE(IDD_KBMAP), hwnd, KBMapProc);
						ShowWindow(hKBMap, SW_SHOW);
					}
				}
				break;

			case ID_HELP_KNOWNISSUES:
				if (NULL == pCurrentHelpMsg) {
					pCurrentHelpMsg="There are no known issues with the currently selected cartridge.";
				}
				MessageBox(myWnd, pCurrentHelpMsg, "Compatibility Notes", MB_ICONINFORMATION|MB_OK);
				break;

			case ID_FILE_SCRAMBLERESET:
				bScrambleMemory=true;
				// fall through
			case ID_FILE_RESET:
				if (LOWORD(wParam) == ID_FILE_RESET) {
					bScrambleMemory=false;
				}

				ST=(ST&0xfff0);							// disable interrupts
				memset(CRU, 1, 4096);					// reset 9901
				CRU[0]=0;								// except not in timer mode
				timer9901=0;
				timer9901IntReq=0;
				starttimer9901=0;
				timer9901IntOk=0;
				wrword(0x83c4,0);						// Console bug work around, make sure no user int is active
				init_kb();								// Reset keyboard emulation
				SetupSams(sams_enabled, sams_size);		// Prepare the AMS system
				readroms();								// reload the real ROMs
				if (NULL != pCurrentHelpMsg) {
					SetWindowText(myWnd, "Classic99 - See Help->Known Issues for this cart");
				} else {
					SetWindowText(myWnd, "Classic99");
				}

				WP=romword(0x0000);						// Reset 
				PC=romword(0x0002);
				for (int idx=0; idx<=PCODEGROMBASE; idx++) {
					GROMBase[idx].grmaccess=2;			// no GROM accesses yet
				}
				nCurrentDSR=-1;
				memset(nDSRBank, 0, sizeof(nDSRBank));
				vdpaccess=0;							// No VDP address writes yet 
				vdpprefetch=0;
				tmpVDPADD=0;							// part of the vdpaccess
				interrupt_needed=0;						// No interrupt missed yet
				CPUSpeechHalt=false;					// not halted for speech reasons
				CPUSpeechHaltByte=0;					// doesn't matter
				cpucount=0;
				cpuframes=0;
				nCycleCount=26;							// not that it's a big deal, but that's how long reset takes ;)
				fKeyEverPressed=false;					// No key pressed yet (to disable the warning on cart change)
				cycles_left=max_cpf=DEFAULT_CPF;
				InterlockedExchange((LONG*)&cycles_left, max_cpf);
				break;

			case ID_FILE_QUIT:
				quitflag=1;
				PostQuitMessage(0);
				break;

			case ID_VIDEO_FLICKER:
				if (lParam != 1) {
					bUse5SpriteLimit=!bUse5SpriteLimit;
				}

				if (!bUse5SpriteLimit) {
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FLICKER, MF_UNCHECKED);
				} else {
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FLICKER, MF_CHECKED);
				}
				break;
			
			case ID_VIDEO_50HZ:
				if (lParam != 1) {
					hzRate=(hzRate==60)?50:60;
				}

				if (hzRate == 60) {
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_50HZ, MF_UNCHECKED);
				} else {
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_50HZ, MF_CHECKED);
				}
				break;

			case ID_VIDEO_STARTRECORDING:
				if (Recording == 0)
				{
					debug_write("Starting AVI recording");
					if (0==InitAvi())
					{
						SetWindowText(myWnd, "Classic99 - Recording AVI");
						Recording=1;
						RecordFrame=0;
					}
				}
				break;
			
			case ID_VIDEO_STOPRECORDING:
				if (Recording)
				{
					debug_write("Stoping AVI recording");
					SetWindowText(myWnd, "Classic99");
					CloseAVI();
					Recording=0;
				}
				break;

			case ID_VIDEO_MAINTAINASPECT:
				if (1 != lParam) {
					MaintainAspect=MaintainAspect?0:1;
				}
				if (MaintainAspect)
				{
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_MAINTAINASPECT, MF_CHECKED);
				}
				else
				{
					CheckMenuItem(GetMenu(myWnd), ID_VIDEO_MAINTAINASPECT, MF_UNCHECKED);
				}
				break;

			case ID_OPTIONS_PAUSEINACTIVE:
				if (1 != lParam) {
					PauseInactive=PauseInactive?0:1;
				}
				if (PauseInactive) {
					CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_PAUSEINACTIVE, MF_CHECKED);
				} else {
					CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_PAUSEINACTIVE, MF_UNCHECKED);
				}
				break;

			case ID_OPTIONS_SPEECHENABLED:
				if (1 != lParam) {
					SpeechEnabled=SpeechEnabled?0:1;
				}
				if (SpeechEnabled) {
					CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_SPEECHENABLED, MF_CHECKED);
				} else {
					CheckMenuItem(GetMenu(myWnd), ID_OPTIONS_SPEECHENABLED, MF_UNCHECKED);
				}
				break;


			case ID_OPTIONS_CPUTHROTTLING:
				{
					// Make sure nothing's left over from the old speed
					InterlockedExchange((LONG*)&cycles_left, 0);

					// Now just used to set the check boxes correctly
					if ((CPUThrottle == CPU_NORMAL) && (SystemThrottle == VDP_CPUSYNC)) {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_NORMAL, MF_CHECKED);
					} else {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_NORMAL, MF_UNCHECKED);
					}

					if ((CPUThrottle == CPU_OVERDRIVE) && (SystemThrottle == VDP_REALTIME)) {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_CPUOVERDRIVE, MF_CHECKED);
					} else {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_CPUOVERDRIVE, MF_UNCHECKED);
					}

					if ((CPUThrottle == CPU_MAXIMUM) && (SystemThrottle == VDP_CPUSYNC)) {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_SYSTEMMAXIMUM, MF_CHECKED);
					} else {
						CheckMenuItem(GetMenu(myWnd), ID_CPUTHROTTLING_SYSTEMMAXIMUM, MF_UNCHECKED);
					}
				}
				break;

			case ID_CPUTHROTTLING_NORMAL:
				CPUThrottle=CPU_NORMAL;
				SystemThrottle=VDP_CPUSYNC;
				PostMessage(myWnd, WM_COMMAND, ID_OPTIONS_CPUTHROTTLING, 1);
				break;

			case ID_CPUTHROTTLING_CPUOVERDRIVE:
				CPUThrottle=CPU_OVERDRIVE;
				SystemThrottle=VDP_REALTIME;
				PostMessage(myWnd, WM_COMMAND, ID_OPTIONS_CPUTHROTTLING, 1);
				break;

			case ID_CPUTHROTTLING_SYSTEMMAXIMUM:
				CPUThrottle=CPU_MAXIMUM;
				SystemThrottle=VDP_CPUSYNC;
				PostMessage(myWnd, WM_COMMAND, ID_OPTIONS_CPUTHROTTLING, 1);
				break;

			case ID_OPTIONS_AUDIO: 
				{
					// Silence during the dialog
					for (int idx=0; idx<3; idx++) {
						voice[idx]->SetVolume(DSBVOLUME_MIN);
					}

					// Create a dialog to reconfigure audio voices
					if (DialogBox(NULL, MAKEINTRESOURCE(IDD_AUDIO), hwnd, AudioBoxProc) == IDOK) {
						for (int idx=0; idx<3; idx++) {
							GenerateToneBuffer(idx);
							voice[idx]->SetVolume(DSBVOLUME_MIN);
							if (FAILED(voice[idx]->Play(0, 0, fSampleShouldLoop[idx]?DSBPLAY_LOOPING:0))) {
								debug_write("Voice DID NOT START");
							}
						}
						// Set speech buffer max volume here
						int nRange=(DSBVOLUME_MIN*max_volume)/100;	// negative
						speechbuf->SetVolume(DSBVOLUME_MIN - nRange);
					}
				}
				break;

			case ID_OPTIONS_OPTIONS:
				{
					// Silence during the dialog
					for (int idx=0; idx<3; idx++) {
						voice[idx]->SetVolume(DSBVOLUME_MIN);
					}

					// Create a dialog to reconfigure generic options
					DialogBox(NULL, MAKEINTRESOURCE(IDD_OPTIONS), hwnd, OptionsBoxProc);
					// It handles the OK/Cancel operation in OptionsBoxProc
				}
				break;

			case ID_OPTIONS_TV:
				// If filters aren't available, tell the user
				if (!TVFiltersAvailable) {
					MessageBox(hwnd, "TV Filter DLL is not available.", "Classic99", MB_OK);
					break;
				}
				// If we aren't in TV mode, switch to it and come back here
				if (4 != FilterMode) {
					PostMessage(hwnd, WM_COMMAND, ID_VIDEO_FILTERMODE_TVMODE, 0);
					PostMessage(hwnd, WM_COMMAND, ID_OPTIONS_TV, 0);
					break;
				}
				// If the TV dialog doesn't already exist, exist it :)
				if (NULL == hTVDlg) {
					// create a modeless dialog to show the TV controls dialog
					hTVDlg=CreateDialog(NULL, MAKEINTRESOURCE(IDD_TVOPTIONS), hwnd, TVBoxProc);
					ShowWindow(hTVDlg, SW_SHOW);
				}
				break;

			case ID_EDITPASTE:
				if (NULL != PasteString) {
					Beep(550,100);
					break;
				}
				if (OpenClipboard(myWnd)) {
					HANDLE data;

					data=GetClipboardData(CF_TEXT);

					if (data) {
						PasteString=(char*)malloc(strlen((char*)data)+1);
						strcpy(PasteString, (char*)data);
						PasteIndex=PasteString;
					}

					CloseClipboard();
				}
				break;
			
			case ID_EDIT_DEBUGGER:
				// activate debugger screen
				if (NULL == dbgWnd) {
					dbgWnd=CreateDialog(NULL, MAKEINTRESOURCE(IDD_DEBUG), myWnd, DebugBoxProc);
					ShowWindow(dbgWnd, SW_SHOW);
				}
				break;

			case ID_VIDEO_STRETCHMODE_NONE:		// This mode is a fallback, it must not fail and must not loop back
				StretchMode=0;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_NONE, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DIB, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DX, MF_UNCHECKED);
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_STRETCHMODE_DIB:
				StretchMode=1;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DIB, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DX, MF_UNCHECKED);
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_STRETCHMODE_DX:
				StretchMode=2;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DIB, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DX, MF_CHECKED);
				takedownDirectDraw();
				SetupDirectDraw(0);
				if (2 != StretchMode) {
					myproc(hwnd, WM_COMMAND, ID_VIDEO_STRETCHMODE_NONE, 0);
				} else {
					InvalidateRect(myWnd, NULL, false);
				}
				break;

			case ID_VIDEO_STRETCHMODE_DXFULL_320X240X8:
			case ID_VIDEO_STRETCHMODE_DXFULL_640X480X8:
			case ID_VIDEO_STRETCHMODE_DXFULL_640X480X16:
			case ID_DXFULL_640X480X32:
			case ID_VIDEO_STRETCHMODE_DXFULL_800X600X16:
			case ID_DXFULL_800X600X32:
			case ID_DXFULL_1024X768X16:
			case ID_DXFULL_1024X768X32:
				StretchMode=3;
				FullScreenMode=wParam-ID_VIDEO_STRETCHMODE_DXFULL_320X240X8+1;
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DIB, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_STRETCHMODE_DX, MF_UNCHECKED);
				{
					for (DWORD idx=ID_VIDEO_STRETCHMODE_DXFULL_320X240X8; idx<ID_DXFULL_1024X768X32; idx++) {
						if (idx==wParam) {
							CheckMenuItem(GetMenu(myWnd), wParam, MF_CHECKED);
						} else {
							CheckMenuItem(GetMenu(myWnd), wParam, MF_UNCHECKED);
						}
					}
				}
				takedownDirectDraw();
				SetupDirectDraw(FullScreenMode);
				if (3 != StretchMode) {
					myproc(hwnd, WM_COMMAND, ID_VIDEO_STRETCHMODE_NONE, 0);
				} else {
					InvalidateRect(myWnd, NULL, false);
				}
				break;

			case ID_VIDEO_FILTERMODE_NONE:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_UNCHECKED);
				if (FilterMode != 0) {
					ResizeBackBuffer(256+16, 192+16);
				}
				FilterMode=0;
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_FILTERMODE_HQ4X:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_UNCHECKED);
				if (FilterMode != 5) {
					ResizeBackBuffer((256+16)*4, (192+16)*4);
				}
				FilterMode=5;
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_FILTERMODE_2XSAI:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_UNCHECKED);
				if (FilterMode != 1) {
					ResizeBackBuffer(512+32,384+29);
				}
				FilterMode=1;
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_FILTERMODE_SUPER2XSAI:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_UNCHECKED);
				if (FilterMode != 2) {
					ResizeBackBuffer(512+32,384+29);
				}
				FilterMode=2;
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_FILTERMODE_SUPEREAGLE:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_CHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_UNCHECKED);
				if (FilterMode != 3) {
					ResizeBackBuffer(512+32,384+29);
				}
				FilterMode=3;
				InvalidateRect(myWnd, NULL, false);
				break;

			case ID_VIDEO_FILTERMODE_TVMODE:
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_NONE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_HQ4X, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPER2XSAI, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_SUPEREAGLE, MF_UNCHECKED);
				CheckMenuItem(GetMenu(myWnd), ID_VIDEO_FILTERMODE_TVMODE, MF_CHECKED);
				if (FilterMode != 4) {
					ResizeBackBuffer(640,384+29);
				}
				FilterMode=4;
				InvalidateRect(myWnd, NULL, false);
				break;

			default:
				return(DefWindowProc(hwnd, msg, wParam, lParam));
			}

		case WM_SIZE: {
				HDC myDC;
				
				if (MaintainAspect)
				{
					GetWindowRect(myWnd, &myrect);
					GetClientRect(myWnd, &myrect2);
					i1=((myrect.right - myrect.left)-(myrect2.right - myrect2.left))/2;
					myrect.left += i1;
					myrect.right = myrect.left + myrect2.right;
					myrect.bottom -= i1;
					myrect.top = myrect.bottom - myrect2.bottom;
					
					height=(float)((myrect.right - myrect.left) * 0.75);
					height-=(myrect.bottom - myrect.top);

					if (height)
					{
						GetWindowRect(myWnd, &myrect);
						myrect.bottom+=(long)height;
						MoveWindow(myWnd, myrect.left, myrect.top, myrect.right-myrect.left, myrect.bottom-myrect.top, true);
					}
				}

				if (0 == StretchMode) {
					GetClientRect(myWnd, &myrect);
					myDC=GetDC(myWnd);
					FillRect(myDC, &myrect, (HBRUSH)(COLOR_MENU+1));
					ReleaseDC(myWnd, myDC);
				}
				}
				break;

		case WM_MOUSEACTIVATE:
				SetEvent(BlitEvent);
				return(DefWindowProc(hwnd, msg, wParam, lParam));
				break;

		case WM_RBUTTONUP:	// exit full screen
				if (3 == StretchMode) {
					StretchMode=2;
					takedownDirectDraw();
					SetupDirectDraw(false);
				}
				break;

		case WM_SETFOCUS: 
			if (PauseInactive) {
				int idx;
				// Re-enable sounds
				for (idx=0; idx<3; idx++) {
					voice[idx]->SetVolume(nOldVolume[idx]);
				}
				for (idx=0; idx<8; idx++) {
					noise[idx]->SetVolume(nOldVolume[idx+3]);
				}
			}
			break;

		case WM_KILLFOCUS:
			// Disable sounds, cache current levels
			if (PauseInactive) {
				int idx;
				for (idx=0; idx<3; idx++) {
					voice[idx]->GetVolume(&nOldVolume[idx]);
					voice[idx]->SetVolume(DSBVOLUME_MIN);
				}
				for (idx=0; idx<8; idx++) {
					noise[idx]->GetVolume(&nOldVolume[idx+3]);
					noise[idx]->SetVolume(DSBVOLUME_MIN);
				}
			}
			// clear all keyboard state
			memset(key, 0, sizeof(key));
			init_kb();
			break;

		default:
			return(DefWindowProc(hwnd, msg, wParam, lParam));
		}
		return 0;
	}

	return(DefWindowProc(hwnd, msg, wParam, lParam));
}


BOOL CALLBACK AudioBoxProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	// tricky
	// IDC_RADIO2 -11 is line 1
	// IDC_RADIO12-21 is line 2
	// IDC_RADIO22-31 is line 3
	int idx;

    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
					// Read new values into nSampleIdx[0..2]
					for (idx=IDC_RADIO2; idx<=IDC_RADIO11; idx++) {
						if (BST_CHECKED == SendDlgItemMessage(hwnd, idx, BM_GETCHECK, 0, 0)) {
							nSampleIdx[0]=idx-IDC_RADIO2;
							break;
						}
					}
					for (idx=IDC_RADIO12; idx<=IDC_RADIO21; idx++) {
						if (BST_CHECKED == SendDlgItemMessage(hwnd, idx, BM_GETCHECK, 0, 0)) {
							nSampleIdx[1]=idx-IDC_RADIO12;
							break;
						}
					}
					for (idx=IDC_RADIO22; idx<=IDC_RADIO31; idx++) {
						if (BST_CHECKED == SendDlgItemMessage(hwnd, idx, BM_GETCHECK, 0, 0)) {
							nSampleIdx[2]=idx-IDC_RADIO22;
							break;
						}
					}
					max_volume=SendDlgItemMessage(hwnd, IDC_SLDVOL, TBM_GETPOS, 0, 0);
                    // Fall through. 
                 case IDCANCEL: 
                    EndDialog(hwnd, wParam); 
                    return TRUE; 

				 case IDC_DEFAULT:
					// set the values to default. (square wave)
					CheckRadioButton(hwnd, IDC_RADIO2, IDC_RADIO11, IDC_RADIO2);
					CheckRadioButton(hwnd, IDC_RADIO12, IDC_RADIO21, IDC_RADIO12);
					CheckRadioButton(hwnd, IDC_RADIO22, IDC_RADIO31, IDC_RADIO22);
					SendDlgItemMessage(hwnd, IDC_SLDVOL, TBM_SETPOS, TRUE, 80);
					return TRUE;
            } 
			break;

		case WM_INITDIALOG:
			SendDlgItemMessage(hwnd, IDC_RADIO2+nSampleIdx[0], BM_SETCHECK, BST_CHECKED, NULL);
			SendDlgItemMessage(hwnd, IDC_RADIO12+nSampleIdx[1], BM_SETCHECK, BST_CHECKED, NULL);
			SendDlgItemMessage(hwnd, IDC_RADIO22+nSampleIdx[2], BM_SETCHECK, BST_CHECKED, NULL);
			SendDlgItemMessage(hwnd, IDC_SLDVOL, TBM_SETRANGE, TRUE, MAKELONG(0,100));
			SendDlgItemMessage(hwnd, IDC_SLDVOL, TBM_SETPOS, TRUE, max_volume);
			return TRUE;
    } 
    return FALSE; 
} 

BOOL CALLBACK OptionsBoxProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
					// Read new values from dialog
					SendDlgItemMessage(hwnd, IDC_AVIFILENAME, WM_GETTEXT, 256, (LPARAM)AVIFileName);
					max_cpf=DEFAULT_CPF*SendDlgItemMessage(hwnd, IDC_SLDCPU, TBM_GETPOS, 0, 0)/10;
					drawspeed=SendDlgItemMessage(hwnd, IDC_SLDFRAMESKIP, TBM_GETPOS, 0, 0);
					slowdown_keyboard=IsDlgButtonChecked(hwnd, IDC_CHKSLOWKEY)?1:0;
					
					if (IsDlgButtonChecked(hwnd, IDC_THROTTLECPU)) {
						CPUThrottle=CPU_NORMAL;
						SystemThrottle=VDP_CPUSYNC;
					}
					if (IsDlgButtonChecked(hwnd, IDC_UNTHROTTLECPU)) {
						CPUThrottle=CPU_OVERDRIVE;
						SystemThrottle=VDP_REALTIME;
					}
					if (IsDlgButtonChecked(hwnd, IDC_UNTHROTTLEALL)) {
						CPUThrottle=CPU_MAXIMUM;
						SystemThrottle=VDP_CPUSYNC;
					}
					{
						// SAMS
						int old_sams_enabled=sams_enabled;
						int old_sams_size=sams_size;
						if (IsDlgButtonChecked(hwnd, IDC_AMS_0K)) {
							sams_enabled=0;
						}
						if (IsDlgButtonChecked(hwnd, IDC_AMS_128K)) {
							sams_enabled=1;
							sams_size=0;
						}
						if (IsDlgButtonChecked(hwnd, IDC_AMS_256K)) {
							sams_enabled=1;
							sams_size=1;
						}
						if (IsDlgButtonChecked(hwnd, IDC_AMS_512K)) {
							sams_enabled=1;
							sams_size=2;
						}
						if (IsDlgButtonChecked(hwnd, IDC_AMS_1024K)) {
							sams_enabled=1;
							sams_size=3;
						}
						if ((sams_enabled!=old_sams_enabled)||(sams_size!=old_sams_size)) {
							// changing this in real time wipes memory, so don't do that!
							int ret;
							ret=MessageBox(hwnd, "This will reset the emulator - are you sure?", "Change AMS Memory size", MB_YESNO|MB_ICONQUESTION);
							if (IDYES == ret) {
								PostMessage(myWnd, WM_COMMAND, ID_FILE_RESET, 0);
							} else {
								sams_enabled=old_sams_enabled;
								sams_size=old_sams_size;
							}
						}
					}

					// joysticks
					fJoy=IsDlgButtonChecked(hwnd, IDC_CHKJOYST)?1:0;
					if (IsDlgButtonChecked(hwnd, IDC_JOY1KEY))  joy1mode=0;
					if (IsDlgButtonChecked(hwnd, IDC_JOY1JOY1)) joy1mode=1;
					if (IsDlgButtonChecked(hwnd, IDC_JOY1JOY2)) joy1mode=2;
					if (IsDlgButtonChecked(hwnd, IDC_JOY2KEY))  joy2mode=0;
					if (IsDlgButtonChecked(hwnd, IDC_JOY2JOY1)) joy2mode=1;
					if (IsDlgButtonChecked(hwnd, IDC_JOY2JOY2)) joy2mode=2;

					// Special - tell the CPU Throttle menu item the new state
					PostMessage(myWnd, WM_COMMAND, ID_OPTIONS_CPUTHROTTLING, 1);
                    // Fall through. 
                 case IDCANCEL: 
                    EndDialog(hwnd, wParam); 
                    return TRUE; 

				 case IDC_BROWSEAVI:
					 // Browse for new AVI filename
					 {
						OPENFILENAME ofn;
						char buf[256];

						memset(&ofn, 0, sizeof(OPENFILENAME));
						ofn.lStructSize=sizeof(OPENFILENAME);
						ofn.hwndOwner=hwnd;
						ofn.lpstrFilter="AVI Files\0*.avi\0\0";
						SendDlgItemMessage(hwnd, IDC_AVIFILENAME, WM_GETTEXT, 256, (LPARAM)buf);
						ofn.lpstrFile=buf;
						ofn.nMaxFile=256;
						ofn.Flags=OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST;

						if (GetSaveFileName(&ofn)) {
						 SendDlgItemMessage(hwnd, IDC_AVIFILENAME, WM_SETTEXT, 0, (LPARAM)ofn.lpstrFile);
						}
					 }

					 return TRUE;
            } 
			break;

		case WM_INITDIALOG:
			// load the controls with current values
			SendDlgItemMessage(hwnd, IDC_AVIFILENAME, WM_SETTEXT, 0, (LPARAM)AVIFileName);
			SendDlgItemMessage(hwnd, IDC_SLDCPU, TBM_SETRANGE, TRUE, MAKELONG(1,20));
			SendDlgItemMessage(hwnd, IDC_SLDCPU, TBM_SETPOS, TRUE, (max_cpf*10)/DEFAULT_CPF);
			SendDlgItemMessage(hwnd, IDC_SLDFRAMESKIP, TBM_SETRANGE, TRUE, MAKELONG(0,10));
			SendDlgItemMessage(hwnd, IDC_SLDFRAMESKIP, TBM_SETPOS, TRUE, drawspeed);
			SendDlgItemMessage(hwnd, IDC_CHKJOYST, BM_SETCHECK, fJoy?BST_CHECKED:BST_UNCHECKED, 0);
			SendDlgItemMessage(hwnd, IDC_CHKSLOWKEY, BM_SETCHECK, slowdown_keyboard?BST_CHECKED:BST_UNCHECKED, 0);
			
			// default
			CheckRadioButton(hwnd, IDC_THROTTLECPU, IDC_UNTHROTTLEALL, IDC_THROTTLECPU);
			if ((CPUThrottle == CPU_OVERDRIVE) && (SystemThrottle == VDP_REALTIME)) {
				CheckRadioButton(hwnd, IDC_THROTTLECPU, IDC_UNTHROTTLEALL, IDC_UNTHROTTLECPU);
			}
			if ((CPUThrottle == CPU_MAXIMUM) && (SystemThrottle == VDP_CPUSYNC)) {
				CheckRadioButton(hwnd, IDC_THROTTLECPU, IDC_UNTHROTTLEALL, IDC_UNTHROTTLEALL);
			}

			CheckRadioButton(hwnd, IDC_JOY1KEY, IDC_JOY1JOY2, IDC_JOY1KEY+joy1mode);
			CheckRadioButton(hwnd, IDC_JOY2KEY, IDC_JOY2JOY2, IDC_JOY2KEY+joy2mode);
			CheckRadioButton(hwnd, IDC_AMS_0K, IDC_AMS_1024K, sams_enabled?sams_size+IDC_AMS_128K:IDC_AMS_0K);
			return TRUE;

    } 
    return FALSE; 
} 

BOOL CALLBACK KBMapProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	// only tricky part is loading the kb image resource
	static HBITMAP hBmp=NULL;
	HWND hWnd=NULL;

    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    // Fall through. 
                 case IDCANCEL: 
                    EndDialog(hwnd, wParam); 
					if (NULL != hBmp) {
						DeleteObject(hBmp);
						hBmp=NULL;
					}
					hKBMap=NULL;
                    return TRUE; 
            } 
			break;

		case WM_INITDIALOG:
			// load the bitmap into the frame
			hWnd=GetDlgItem(hwnd, IDC_IMAGE);
			if (NULL != hWnd) {
				hBmp=LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_KBMAP));
				if (NULL != hBmp) {
					SendMessage(hWnd, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hBmp);
				}
			}
			return TRUE;
    } 
    return FALSE; 
} 

BOOL CALLBACK BreakPointHelpProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	// nothing fancy here
    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    // Fall through. 
                 case IDCANCEL: 
                    EndDialog(hwnd, wParam); 
					hBrkHlp=NULL;
                    return TRUE; 
            } 
			break;

		case WM_INITDIALOG:
			return TRUE;
    } 
    return FALSE; 
} 

// External references
BOOL CALLBACK TVBoxProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	static double hue=0, sat=0, cont=0, bright=0, sharp=0;
	double thue, tsat, tcont, tbright, tsharp, tmp;

    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
					TVScanLines=IsDlgButtonChecked(hwnd, IDC_SCANLINES)?1:0;

					// Read the values one more time
					tmp=SendDlgItemMessage(hwnd, IDC_HUE, TBM_GETPOS, 0, 0);
					thue=(tmp-100)/100.0;
					tmp=SendDlgItemMessage(hwnd, IDC_SAT, TBM_GETPOS, 0, 0);
					tsat=(tmp-100)/100.0;
					tmp=SendDlgItemMessage(hwnd, IDC_CONT, TBM_GETPOS, 0, 0);
					tcont=(tmp-100)/100.0;
					tmp=SendDlgItemMessage(hwnd, IDC_BRIGHT, TBM_GETPOS, 0, 0);
					tbright=(tmp-100)/100.0;
					tmp=SendDlgItemMessage(hwnd, IDC_SHARP, TBM_GETPOS, 0, 0);
					tsharp=(tmp-100)/100.0;

					SetTVValues(thue, tsat, tcont, tbright, tsharp);
					InvalidateRect(myWnd, NULL, false);

                    EndDialog(hwnd, wParam); 
					hTVDlg=NULL;
                    return TRUE; 

				case IDCANCEL: 
					// set back to cached values (note: no cancel button on dialog today!)
					SetTVValues(hue, sat, cont, bright, sharp);
                    EndDialog(hwnd, wParam); 
					hTVDlg=NULL;
                    return TRUE; 

				case IDC_RESET:
					SetTVValues(0, 0, 0, 0, 0);
					InvalidateRect(myWnd, NULL, false);
					
					SendDlgItemMessage(hwnd, IDC_HUE, TBM_SETPOS, TRUE, 100);
					SendDlgItemMessage(hwnd, IDC_SAT, TBM_SETPOS, TRUE, 100);
					SendDlgItemMessage(hwnd, IDC_CONT, TBM_SETPOS, TRUE, 100);
					SendDlgItemMessage(hwnd, IDC_BRIGHT, TBM_SETPOS, TRUE, 100);
					SendDlgItemMessage(hwnd, IDC_SHARP, TBM_SETPOS, TRUE, 100);
					return TRUE;

				 case IDC_SCANLINES:
					TVScanLines=IsDlgButtonChecked(hwnd, IDC_SCANLINES)?1:0;
					InvalidateRect(myWnd, NULL, false);
					return TRUE;
            } 
			break;

		case WM_VSCROLL:
			if (NULL != lParam) {
				switch (LOWORD(wParam)) {
					case SB_THUMBPOSITION:
					case SB_THUMBTRACK:
						// High word contains absolute position
						tmp=(HIWORD(wParam)-100)/100.0;
						GetTVValues(&thue, &tsat, &tcont, &tbright, &tsharp);
						if (lParam == (long)GetDlgItem(hwnd, IDC_HUE)) {
							thue=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_SAT)) {
							tsat=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_CONT)) {
							tcont=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_BRIGHT)) {
							tbright=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_SHARP)) {
							tsharp=tmp;
						}
						SetTVValues(thue, tsat, tcont, tbright, tsharp);
						InvalidateRect(myWnd, NULL, false);
						break;

					case SB_BOTTOM:
					case SB_TOP:
					case SB_LINEDOWN:
					case SB_LINEUP:
					case SB_PAGEDOWN:
					case SB_PAGEUP:
					case SB_ENDSCROLL:
						// Need to query for the position (mostly keyboard interface)
						tmp=SendMessage((HWND)lParam, TBM_GETPOS, 0, 0);
						tmp=(tmp-100)/100.0;
						GetTVValues(&thue, &tsat, &tcont, &tbright, &tsharp);
						if (lParam == (long)GetDlgItem(hwnd, IDC_HUE)) {
							thue=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_SAT)) {
							tsat=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_CONT)) {
							tcont=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_BRIGHT)) {
							tbright=tmp;
						}
						if (lParam == (long)GetDlgItem(hwnd, IDC_SHARP)) {
							tsharp=tmp;
						}
						SetTVValues(thue, tsat, tcont, tbright, tsharp);
						InvalidateRect(myWnd, NULL, false);
						break;
				}
			}
			return 0;

		case WM_INITDIALOG:
			// cache the current values in case we cancel
			GetTVValues(&hue, &sat, &cont, &bright, &sharp);

			// load the controls with current values
			SendDlgItemMessage(hwnd, IDC_HUE, TBM_SETRANGE, TRUE, MAKELONG(0,200));
			SendDlgItemMessage(hwnd, IDC_HUE, TBM_SETPOS, TRUE, (int)((hue+1.0)*100));

			SendDlgItemMessage(hwnd, IDC_SAT, TBM_SETRANGE, TRUE, MAKELONG(0,200));
			SendDlgItemMessage(hwnd, IDC_SAT, TBM_SETPOS, TRUE, (int)((sat+1.0)*100));

			SendDlgItemMessage(hwnd, IDC_CONT, TBM_SETRANGE, TRUE, MAKELONG(0,200));
			SendDlgItemMessage(hwnd, IDC_CONT, TBM_SETPOS, TRUE, (int)((cont+1.0)*100));

			SendDlgItemMessage(hwnd, IDC_BRIGHT, TBM_SETRANGE, TRUE, MAKELONG(0,200));
			SendDlgItemMessage(hwnd, IDC_BRIGHT, TBM_SETPOS, TRUE, (int)((bright+1.0)*100));

			SendDlgItemMessage(hwnd, IDC_SHARP, TBM_SETRANGE, TRUE, MAKELONG(0,200));
			SendDlgItemMessage(hwnd, IDC_SHARP, TBM_SETPOS, TRUE, (int)((sharp+1.0)*100));

			SendDlgItemMessage(hwnd, IDC_SCANLINES, BM_SETCHECK, TVScanLines?BST_CHECKED:BST_UNCHECKED, 0);

			return TRUE;

    } 
    return FALSE; 
} 

// true if parsed successfully
// Note that buf1 is modified in place!
bool AddBreakpoint(char *buf1) {
	bool bRet=false;
	int x;

	if (1 == sscanf(buf1, "%x", &x)) {
		if (x != 0) {
			x&=0xffff;
			sprintf(buf1, "%04X", x);
			bRet=true;
			BreakPointType[nBreakPoints]=BREAK_PC;
			BreakPoint[nBreakPoints++]=x;
		}
	} else {
		int nType=BREAK_NONE;
		int nTmp=0;
		char *pTmp;
		
		buf1[0]=toupper(buf1[0]);
		switch (buf1[0]) {
		case '*':	// memory address access (read or write)
			nType=BREAK_ACCESS;
			break;
		case '>':	// write to address
			nType=BREAK_WRITE;
			break;
		case '<':	// read from address
			nType=BREAK_READ;
			break;
		case 'W':	// Word =
			nType=BREAK_EQUALS_WORD;
			pTmp=strchr(buf1, '=');
			if (NULL == pTmp) {
				nType=BREAK_NONE;
			} else {
				if (1 != sscanf(pTmp+1, "%x", &nTmp)) {
					nType=BREAK_NONE;
				} else {
					nType|=(nTmp&0xffff)<<8;
				}
			}
			break;
		case 'M':	// Memory = 
			nType=BREAK_EQUALS_BYTE;
			pTmp=strchr(buf1, '=');
			if (NULL == pTmp) {
				nType=BREAK_NONE;
			} else {
				if (1 != sscanf(pTmp+1, "%x", &nTmp)) {
					nType=BREAK_NONE;
				} else {
					nType|=(nTmp&0xff)<<8;
				}
			}
			break;
		case 'U':	// VDP register =
			nType=BREAK_EQUALS_VDPREG;
			pTmp=strchr(buf1, '=');
			if (NULL == pTmp) {
				nType=BREAK_NONE;
			} else {
				if (1 != sscanf(pTmp+1, "%x", &nTmp)) {
					nType=BREAK_NONE;
				} else {
					nType|=(nTmp&0xff)<<8;
				}
			}
			break;
		case 'V':	// VDP memory =
			nType=BREAK_EQUALS_VDP;
			pTmp=strchr(buf1, '=');
			if (NULL == pTmp) {
				nType=BREAK_NONE;
			} else {
				if (1 != sscanf(pTmp+1, "%x", &nTmp)) {
					nType=BREAK_NONE;
				} else {
					nType|=(nTmp&0xff)<<8;
				}
			}
			break;
		case 'R':	// Register =
			nType=BREAK_EQUALS_REGISTER;
			pTmp=strchr(buf1, '=');
			if (NULL == pTmp) {
				nType=BREAK_NONE;
			} else {
				if (1 != sscanf(pTmp+1, "%x", &nTmp)) {
					nType=BREAK_NONE;
				} else {
					nType|=(nTmp&0xffff)<<8;
				}
			}
			break;

		case 'S':	// Start timing loop
			nType=BREAK_START_TIMER;
			break;
		case 'X':	// Exit timing loop
			nType=BREAK_EXIT_TIMER;
			break;
		}

		if (nType != BREAK_NONE) {
			if (1 == sscanf(&buf1[1], "%x", &x)) {
				x&=0xffff;
				if (buf1[0]=='W') {
					sprintf(buf1, "%c%04X=%04X", buf1[0], x, (nType&0xFFFF00)>>8);
				} else if ((buf1[0]=='M') || (buf1[0]=='V')) {
					sprintf(buf1, "%c%04X=%02X", buf1[0], x, (nType&0xFF00)>>8);
				} else if (buf1[0] == 'U') {
					x&=0x07;
					sprintf(buf1, "%c%d=%02X", buf1[0], x, (nType&0xFF00)>>8);
				} else if (buf1[0]=='R') {
					// decimal! re-scan
					sscanf(&buf1[1], "%d", &x);
					x&=0x0f;
					sprintf(buf1, "%c%d=%04X", buf1[0], x, (nType&0xFFFF00)>>8);
				} else {
					sprintf(buf1, "%c%04X", buf1[0], x);
				}
				bRet=true;
				BreakPointType[nBreakPoints]=nType;
				BreakPoint[nBreakPoints++]=x;
			}
		}
	}

	return bRet;
}

BOOL CALLBACK DebugBoxProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	char buf1[80];
	int idx;

    switch (uMsg) 
    { 
        case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
				case IDOK: 
				case IDCANCEL: 
                    EndDialog(hwnd, wParam); 
					dbgWnd=NULL;
                    return TRUE; 

				case IDC_RADIO1:
					bDebugDirty=true;
					// fall through
				case IDC_RADIO2:
				case IDC_RADIO3:
				case IDC_RADIO4:
				case IDC_RADIO5:
					nMemType=LOWORD(wParam)-IDC_RADIO1;
					SetDlgItemText(hwnd, IDC_ADDRESS, szTopMemory[nMemType]);
					SetEvent(hDebugWindowUpdateEvent);
					break;

				case IDC_ADDBREAK:
					{
						// add a new breakpoint
						if (nBreakPoints >= MAX_BREAKPOINTS) {
							Beep(550,100);
							break;
						}
						if (SendDlgItemMessage(hwnd, IDC_COMBO1, WM_GETTEXT, 80, (LPARAM)buf1) > 0) {
							if (AddBreakpoint(buf1)) {
								SendDlgItemMessage(hwnd, IDC_COMBO1, CB_ADDSTRING, 0, (LPARAM)buf1);
							}
						}
					}
					break;

				case IDC_REMOVEBREAK:
					{
						int n;
						while (CB_ERR != (n=SendDlgItemMessage(hwnd, IDC_COMBO1, CB_GETCURSEL, 0, 0))) {
							SendDlgItemMessage(hwnd, IDC_COMBO1, CB_DELETESTRING, n, 0);
						}
						// rebuild the breakpoint list
						nBreakPoints=0;
						n=SendDlgItemMessage(hwnd, IDC_COMBO1, CB_GETCOUNT, 0, 0);
						while (n > 0) {
							char buf[32];
							strcpy(buf, "");
							SendDlgItemMessage(hwnd, IDC_COMBO1, CB_GETLBTEXT, n-1, (LPARAM)buf);
							if (strlen(buf)) {
								AddBreakpoint(buf);
							}
							n--;
						}
					}
					break;

				case IDC_BREAKHELP:
					{
						if (NULL == hBrkHlp) {
							// create a modeless dialog to show the breakpoint help
							hBrkHlp=CreateDialog(NULL, MAKEINTRESOURCE(IDD_BRKHLP), hwnd, BreakPointHelpProc);
							ShowWindow(hBrkHlp, SW_SHOW);
						}
					}
					break;

// max lines is 34, each line is 8 bytes
#define LINES_TO_STEP 32
				case IDC_NEXT:
					switch (nMemType) {
						case 2:		// CPU
						case 3:		// VDP
						case 4:		// GROM
							// step forward in memory 
							{
								int x;
								// validate it
								if (1 == sscanf(szTopMemory[nMemType], "%X", &x)) {
									// it is a number, not a register
									x+=(LINES_TO_STEP*8);
									sprintf(szTopMemory[nMemType], "%04X", x);
									SetDlgItemText(hwnd, IDC_ADDRESS, szTopMemory[nMemType]);
								}
								// refresh the dialog
								SetEvent(hDebugWindowUpdateEvent);
							}
							break;
					}
					break;

				case IDC_PREV:
					switch (nMemType) {
						case 2:		// CPU
						case 3:		// VDP
						case 4:		// GROM
							// step back in memory 
							{
								int x;
								// validate it
								if (1 == sscanf(szTopMemory[nMemType], "%X", &x)) {
									// it is a number, not a register
									x-=(LINES_TO_STEP*8);
									sprintf(szTopMemory[nMemType], "%04X", x);
									SetDlgItemText(hwnd, IDC_ADDRESS, szTopMemory[nMemType]);
								}
								// refresh the dialog
								SetEvent(hDebugWindowUpdateEvent);
							}
							break;
					}
					break;

				case IDC_APPLY:
					switch (nMemType) {
						case 1:		// disassembly
							{
								char buf[128];
								int x;
								memset(buf, 0, sizeof(buf));
								GetDlgItemText(hwnd, IDC_ADDRESS, buf, 128);
								if (1 == sscanf(buf, "PC=%X", &x)) {
									// make a change to the Program Counter
									PC=x;
									// refresh the dialog
									SetEvent(hDebugWindowUpdateEvent);
								}
							}
							break;

						case 2:		// CPU
						case 3:		// VDP
						case 4:		// GROM
							{
								char buf[128];
								int x,y;
								int ok,byte,romok;
								memset(buf, 0, sizeof(buf));
								GetDlgItemText(hwnd, IDC_ADDRESS, buf, 128);
								// validate it
								if (strchr(buf, '=')) {
									// this is a write command!
									// remove leading whitespace that might screw up the register check
									while (isspace(buf[0])) {
										memmove(&buf[0], &buf[1], sizeof(buf)-1);
									}
									if (buf[0]=='R') buf[0]='r';
									if ((2 == sscanf(buf, "%X=%X", &x, &y)) || (2 == sscanf(buf, "r%d=%X", &x, &y))) {
										// make a change -- convert x if register
										if (buf[0]=='r') {
											if ((nMemType == 2) || (nMemType == 3)) {  // CPU or VDP
												x=-(x+1);	// registers are -1 (R0) to -16 (R15) (to -8 (R7) for VDP)
											} else {
												// no registers elsewhere
												MessageBox(hwnd, "No registers on this memory type", "Classic99 Debugger", MB_ICONSTOP);
												break;
											}
										}
										// check if y is byte or word
										char *p=strchr(buf,'=');
										p++;
										byte=0;
										while (isspace(*p)) p++;
										while (isalnum(*p)) {
											byte++;
											p++;
										}
										if ((byte > 2) && (nMemType == 2)) {
											byte = 0;		// no, word -- only the CPU supports this
											y&=0xffff;
										} else {
											byte = 1;		// yes, byte
											y&=0xff;
										}
										// do various warnings/errors
										ok=IDYES;
										switch (nMemType) {
											case 2:		// CPU
												if (x < -16) {
													MessageBox(hwnd, "Out of range for CPU registers", "Classic99 Debugger", MB_ICONSTOP);
													ok=IDNO;
												} else if (ROMMAP[x]) {
													ok=MessageBox(hwnd, "Modify ROM? (Bank 0 only, non-permanent)\nif you answer no, the write will be performed normally.", "Classic99 Debugger", MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);
													if (ok == IDYES) {
														romok=1;
													} else {
														romok=0;
													}
													// allow it either way
													ok=IDYES;
												} else {
													ok=IDYES;
												}
												break;
											case 3:		// VDP
												if (x > 0x3FFF) {
													MessageBox(hwnd, "Out of range for VDP address", "Classic99 Debugger", MB_ICONSTOP);
													ok=IDNO;
												}
												if (x < -8) {
													MessageBox(hwnd, "Out of range for VDP registers", "Classic99 Debugger", MB_ICONSTOP);
													ok=IDNO;
												}
												break;
											case 4:		// GROM
												ok=MessageBox(hwnd, "Modify GROM? (Base 0 only, non-permanent)", "Classic99 Debugger", MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);
												break;
											default:
												ok=IDNO;
												break;
										}
										if (ok == IDYES) {
											// CPU writes /are/ allowed to cause side effects!
											switch (nMemType) {
												case 2:		// CPU again
													if (x < 0) {
														// convert negative register index to address
														x=WP - ((x+1)*2);
													}
													if (byte) {
														if ((ROMMAP[x]) && (romok)) {
															// need to be direct
															staticCPU[x]=y;
														} else {
															// do this so side effects work
															wcpubyte(x, y);
														}
													} else {
														if ((ROMMAP[x]) && (romok)) {
															// need to be direct
															staticCPU[x]=y>>8;
															staticCPU[x+1]=y&0xff;
														} else {
															// do this so side effects work
															wrword(x, y);
														}
													}
													break;

												case 3:		// VDP again
													if (x < 0) {
														// it's a register
														VDPREG[(-x)-1] = y;
													} else {
														VDP[x] = y;
													}
													// force VDP to update
													SetEvent(DisplayEvent);
													break;

												case 4:		// GROM 
													// only base zero handled
													GROMBase[0].GROM[x]=y;
													break;
											}
										}
									} else {
										MessageBox(hwnd, "Use XXXX=XX to set a value (both values in hex)\nor Rx=XX for a register (register index in decimal)", "Unrecognized string", MB_ICONASTERISK);
									}
								} else {
									if ((1 == sscanf(buf, "%X", &x)) || (tolower(buf[0])=='r')) {
										strcpy(szTopMemory[nMemType], buf);
									}
								}
								// refresh the dialog
								SetEvent(hDebugWindowUpdateEvent);
							}
							break;
					}
					break;

				case IDC_EDITMEM:
				;

				case IDC_PAUSE:
					DoPause();
					break;

				case IDC_STEP:
					DoStep();
					break;

				case IDC_STEP_OVER:
					DoStepOver();
					break;

				case IDC_PLAY:
					DoPlay();
					break;

				case IDC_FASTFORWARD:
					DoFastForward();
					break;

				case IDC_FREEZE:
					if (bFrozenText) {
						bFrozenText=false;
						SendDlgItemMessage(hwnd, IDC_FREEZE, WM_SETTEXT, NULL, (LPARAM)"Freeze");
					} else {
						bFrozenText=true;
						SendDlgItemMessage(hwnd, IDC_FREEZE, WM_SETTEXT, NULL, (LPARAM)"UnFreeze");
					}
					break;
            } 
			break;

		case WM_INITDIALOG:
			CheckRadioButton(hwnd, IDC_RADIO1, IDC_RADIO5, IDC_RADIO1);
			nMemType=0;
			SendDlgItemMessage(hwnd, IDC_MAINEDIT, WM_SETTEXT, NULL, (LPARAM)"");

			// breakpoints
			SendDlgItemMessage(hwnd, IDC_COMBO1, CB_RESETCONTENT, NULL, NULL);
			for (idx=0; idx<nBreakPoints; idx++) {
				char buf[128];
				sprintf(buf, "0x%04X", BreakPoint[idx]);
				SendDlgItemMessage(hwnd, IDC_COMBO1, CB_ADDSTRING, NULL, (LPARAM)buf);
			}
			SendDlgItemMessage(hwnd, IDC_COMBO1, CB_LIMITTEXT, 10, NULL);
			// fall through
		case WM_APP:
			// refresh the dialog
			SetEvent(hDebugWindowUpdateEvent);
			return TRUE;
    } 
    return FALSE; 
} 

void DebugUpdateThread(void*) {
	static int nOldPC=0;
	static int nOldMemType=-1;
	static char szOldMemory[5][32] = { "", "", "", "", "" };
	char buf1[80], buf2[80];
	int myPC, idx, idx2;
	int tmpPC;
	HWND hWnd;

	while (!quitflag) {
		if (WAIT_TIMEOUT == WaitForSingleObject(hDebugWindowUpdateEvent, 500)) {
			continue;
		}

		if (NULL == dbgWnd) {
			continue;
		}

		// Helps a bit -- not much can change unless the PC does ;)
		if ((nOldPC == PC) && (nOldMemType == nMemType) && (0 == memcmp(szOldMemory, szTopMemory, sizeof(szOldMemory)))) {
			continue;
		}

		nOldPC=PC;
		nOldMemType=nMemType;

		// Debug window
		hWnd=GetDlgItem(dbgWnd, IDC_MAINEDIT);
		if (NULL != hWnd) {
			CString csOut;

			if (!bFrozenText) {
				switch (nMemType) {
					case 0:		// debug
						if (bDebugDirty) {
							for (idx=1; idx<34; idx++) {
								csOut+=lines[idx];
								csOut+="\r\n";
							}
							bDebugDirty=false;
						}
						break;

					case 1:		// disassembly
						{
							for (idx=0; idx<20; idx++) {
								Dasm9900(buf2, disasm[idx]);
								sprintf(buf1, "  %04X   %-30s\r\n", disasm[idx], buf2);
								csOut+=buf1;
							}

							myPC=PC;
							
							tmpPC = myPC;
							myPC += Dasm9900(buf2, myPC);
							myPC&=0xffff;

							sprintf(buf1, "> %04X   %-30s\r\n", tmpPC, buf2);
							csOut+=buf1;

							for (idx=0; idx<13; idx++) {
								tmpPC = myPC;
								myPC += Dasm9900(buf2, myPC);
								myPC&=0xffff;
								sprintf(buf1, "  %04X   %-30s\r\n", tmpPC, buf2);
								csOut+=buf1;
							}

						}
						break;

					case 2:		// CPU Memory
						{
							// CPU must not call the read function, as it may call the memory
							// mapped devices and affect them. This code does not take into
							// account scratchpad or cartridge ROM banks
							char buf3[32];
							int c;
							strncpy(buf3, szTopMemory[nMemType], 32);
							buf3[31]='\0';
							if (1 != sscanf(buf3, "%X", &tmpPC)) {
								tmpPC=0;
								if (tolower(buf3[0])=='r') {
									c=atoi(&buf3[1])*2;
									tmpPC=GetSafeByte(WP+c)*256 + GetSafeByte(WP+c+1);
								}
							}
							tmpPC&=0xffff;
							for (idx2=0; idx2<34; idx2++) {
								sprintf(buf1, "%04X: ", tmpPC);
								strcpy(buf3, "");
								for (idx=0; idx<8; idx++) {
									c=GetSafeByte(tmpPC++);
									tmpPC&=0xffff;
									sprintf(buf2, "%02X ", c);
									strcat(buf1, buf2);
									if ((c>=32)&&(c<=126)) {
										buf2[0]=c;
									} else {
										buf2[0]='.';
									}
									buf2[1]='\0';
									strcat(buf3, buf2);
								}
								strcat(buf1, buf3);
								csOut+=buf1;
								csOut+="\r\n";
							}
						}
						break;

					case 3:		// VDP Memory
						{
							// VDP and GROM *must not* call the read functions, as it will
							// change the address!! (But, since we don't do bank switching in them...)
							char buf3[32];
							int c;
							strncpy(buf3, szTopMemory[nMemType], 32);
							buf3[31]='\0';
							if (1 != sscanf(buf3, "%X", &tmpPC)) {
								tmpPC=0;
								if (tolower(buf3[0])=='r') {
									c=atoi(&buf3[1])*2;
									tmpPC=GetSafeByte(WP+c)*256 + GetSafeByte(WP+c+1);
								}
							}
							tmpPC&=0x3fff;
							for (idx2=0; idx2<34; idx2++) {
								sprintf(buf1, "%04X: ", tmpPC);
								strcpy(buf3, "");
								for (idx=0; idx<8; idx++) {
									c=VDP[tmpPC++];
									tmpPC&=0x3fff;
									sprintf(buf2, "%02X ", c);
									strcat(buf1, buf2);
									if ((c>=32)&&(c<=126)) {
										buf2[0]=c;
									} else {
										buf2[0]='.';
									}
									buf2[1]='\0';
									strcat(buf3, buf2);
								}
								strcat(buf1, buf3);
								csOut+=buf1;
								csOut+="\r\n";
							}
						}
						break;

					case 4:		// GROM
							// VDP and GROM *must not* call the read functions, as it will
							// change the address!! (But, since we don't do bank switching in them...)
							// Bug: GROM base 0 only
							char buf3[32];
							int c;
							strncpy(buf3, szTopMemory[nMemType], 32);
							buf3[31]='\0';
							if (1 != sscanf(buf3, "%X", &tmpPC)) {
								tmpPC=0;
								if (tolower(buf3[0])=='r') {
									c=atoi(&buf3[1])*2;
									tmpPC=GetSafeByte(WP+c)*256 + GetSafeByte(WP+c+1);
								}
							}
							for (idx2=0; idx2<34; idx2++) {
								sprintf(buf1, "%04X: ", tmpPC);
								strcpy(buf3, "");
								for (idx=0; idx<8; idx++) {
									c=GROMBase[0].GROM[tmpPC++];
									tmpPC&=0xffff;
									sprintf(buf2, "%02X ", c);
									strcat(buf1, buf2);
									if ((c>=32)&&(c<=126)) {
										buf2[0]=c;
									} else {
										buf2[0]='.';
									}
									buf2[1]='\0';
									strcat(buf3, buf2);
								}
								strcat(buf1, buf3);
								csOut+=buf1;
								csOut+="\r\n";
							}
							break;
				}
				if (!csOut.IsEmpty()) {
					SendMessage(hWnd, WM_SETTEXT, NULL, (LPARAM)(LPCSTR)csOut);
				}
			}
		}

		// Now draw the Registers and other controls
		// we use caching to reduce the interface time, as it can be slow
		static int nOldReg[16]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
		for (idx=IDC_EDIT2; idx<=IDC_EDIT17; idx++) {
			// CPU registers
			int nCnt=idx-IDC_EDIT2;
			int val=GetSafeWord(WP+(nCnt)*2);
			if (val != nOldReg[nCnt]) {
				nOldReg[nCnt]=val;
				sprintf(buf1, "%04X", val);
				SendDlgItemMessage(dbgWnd, idx, WM_SETTEXT, NULL, (LPARAM)buf1);
			}
		}

		static int nOldVDP[8]={-1,-1,-1,-1,-1,-1,-1,-1};
		for (idx=IDC_EDIT18; idx<=IDC_EDIT25; idx++) {
			// VDP registers
			int nCnt=idx-IDC_EDIT18;
			if (VDPREG[nCnt] != nOldVDP[nCnt]) {
				nOldVDP[nCnt]=VDPREG[nCnt];
				sprintf(buf1, "%04X", VDPREG[nCnt]);
				SendDlgItemMessage(dbgWnd, idx, WM_SETTEXT, NULL, (LPARAM)buf1);
			}
		}

		// miscellaneous ones
		static int nOldVDPAdd=-1;
		if (VDPADD != nOldVDPAdd) {
			nOldVDPAdd=VDPADD;
			sprintf(buf1, "%04X", VDPADD);
			SendDlgItemMessage(dbgWnd, IDC_EDIT26, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldGRMAdd=-1;
		if (GROMBase[0].GRMADD != nOldGRMAdd) {
			nOldGRMAdd=GROMBase[0].GRMADD;
			sprintf(buf1, "%04X", GROMBase[0].GRMADD);
			SendDlgItemMessage(dbgWnd, IDC_EDIT27, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldVDPS=-1;
		if (VDPS!=nOldVDPS) {
			nOldVDPS=VDPS;
			sprintf(buf1, "%04X", VDPS);
			SendDlgItemMessage(dbgWnd, IDC_EDIT28, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		// PC had to change to get this far in
		sprintf(buf1, "%04X", PC);
		SendDlgItemMessage(dbgWnd, IDC_EDIT29, WM_SETTEXT, NULL, (LPARAM)buf1);

		static int nOldWP=-1;
		if (nOldWP != WP) {
			nOldWP=WP;
			sprintf(buf1, "%04X", WP);
			SendDlgItemMessage(dbgWnd, IDC_EDIT30, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldST=-1;
		if (nOldST != ST) {
			nOldST=ST;
			sprintf(buf1, "%04X", ST);
			SendDlgItemMessage(dbgWnd, IDC_EDIT31, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldSIT=-1;
		if (nOldSIT != SIT) {
			nOldSIT=SIT;
			sprintf(buf1, "%04X", SIT);
			SendDlgItemMessage(dbgWnd, IDC_EDIT34, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldSAL=-1;
		if (nOldSAL != SAL) {
			nOldSAL=SAL;
			sprintf(buf1, "%04X", SAL);
			SendDlgItemMessage(dbgWnd, IDC_EDIT35, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldSDT=-1;
		if (nOldSDT != SDT) {
			nOldSDT=SDT;
			sprintf(buf1, "%04X", SDT);
			SendDlgItemMessage(dbgWnd, IDC_EDIT36, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldPDT=-1;
		if (nOldPDT != PDT) {
			nOldPDT=PDT;
			sprintf(buf1, "%04X", PDT);
			SendDlgItemMessage(dbgWnd, IDC_EDIT37, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldPDTSize=-1;
		if (nOldPDTSize != PDTsize) {
			nOldPDTSize=PDTsize;
			sprintf(buf1, "%04X", PDTsize);
			SendDlgItemMessage(dbgWnd, IDC_EDIT38, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldBank=-1;
		{
			int nTmp=(xb<<8)|(xbBank);
			if (nTmp != nOldBank) {
				nOldBank=nTmp;
				sprintf(buf1, "%04X", nTmp);
				SendDlgItemMessage(dbgWnd, IDC_EDIT32, WM_SETTEXT, NULL, (LPARAM)buf1);
			}
		}

		static int nOldDSR=-2;
		if (nOldDSR != nCurrentDSR) {
			nOldDSR=nCurrentDSR;
			if (-1 == nCurrentDSR) {
				sprintf(buf1, "%04X", 0xff00);
			} else {
				sprintf(buf1, "%04X", (0x1000|(nCurrentDSR<<8)+nDSRBank[nCurrentDSR]));
			}
			SendDlgItemMessage(dbgWnd, IDC_EDIT33, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldCT=-1;
		if (nOldCT != CT) {
			nOldCT=CT;
			sprintf(buf1, "%04X", CT);
			SendDlgItemMessage(dbgWnd, IDC_EDIT39, WM_SETTEXT, NULL, (LPARAM)buf1);
		}

		static int nOldCTsize=-1;
		if (nOldCTsize != CTsize) {
			nOldCTsize=CTsize;
			sprintf(buf1, "%04X", CTsize);
			SendDlgItemMessage(dbgWnd, IDC_EDIT40, WM_SETTEXT, NULL, (LPARAM)buf1);
		}
	}
}
